#!/bin/bash
#
# landisk-update.sh
#
# $Id$
#

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin

MODEL=`sed -n '/^model/s/^model	//p' /etc/landisk/conffiles/config-system`

ROOTPATH='/mnt/hda5/.update'

VERFILE="${ROOTPATH}/for_${MODEL}_series"
UPFILE="/boot/.update/update.tgz"
TARFILE="${ROOTPATH}/update-files.tar.gz"
BETAFILE="${ROOTPATH}/beta"
UPPERL="${ROOTPATH}/update.pl"

UPDATEVER=`sed 's/-.*$//' $VERFILE`
if [ "$MODEL" = "HDL-GW" -o "$MODEL" = "HDL-GZ" ]; then
    UPDATESUBVER=`sed 's/^[0-9]*\.[0-9]*//' $VERFILE`
fi
[ -f $BETAFILE ] && BETA=`cat $BETAFILE`

start_led() {
   /usr/local/bin/ledcont stsfastblink 
}

exit_select() {
#    /usr/local/bin/ledcont errfastblink
#    /usr/local/bin/buzcont 10 50 3
    exit $1
}
########################
# start
start_led


# perlでアップデート
${UPPERL} --update
if [ $? != 0 ]; then
    exit_select 3
fi

# サービスの停止の布石
SERVICE=`${UPPERL} --getservice 2>/dev/null | awk -F '=' '{print $1}'`

# remount rw /
mount -o remount,rw,noatime /

# サービスの停止
for i in $SERVICE apache2 HDLFind.sh cron xinetd sysklogd networking
do
    /etc/init.d/$i stop
done

# 必要であれば
#killall buttond
#killall usbhdmng

# tarで展開
# dlna databaseは上書きしない(1.10)
if [ -d /mnt/hda5/dmsf_data ]; then
	tar xpzf ${TARFILE} -C / --exclude ./mnt/hda5/dmsf_data || exit_select 1
else
	tar xpzf ${TARFILE} -C / || exit_select 1
fi

# ファイルを削除する
rm -f $UPFILE $TARFILE $BETAFILE $VERFILE

# 終了処理

${UPPERL} --setversion=$DUMMY
echo "success($DUMMY)" > /mnt/hda5/.update/update.log
